"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.translateMass = exports.translateTerm = exports.translatePost = exports.updateSettings = exports.deleteLanguage = exports.updateLanguage = exports.addLanguage = exports.getLanguages = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _services = require("../services");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

const getLanguages = async (_ref, dispatch, config) => {
  let {} = _ref;
  const result = await _services.languageServices.getLanguages({}, dispatch, config);
  return result;
};

exports.getLanguages = getLanguages;

const addLanguage = async (args, dispatch, config) => {
  const result = await _services.languageServices.addLanguage(args, dispatch, config);

  if (result) {
    dispatch({
      type: 'UPDATE_LANGUAGES',
      payload: {
        siteID: args.siteID,
        languages: result
      }
    });
  }

  return result;
};

exports.addLanguage = addLanguage;

const updateLanguage = async (args, dispatch, config) => {
  const result = await _services.languageServices.updateLanguage(args, dispatch, config);

  if (result) {
    dispatch({
      type: 'UPDATE_LANGUAGES',
      payload: {
        siteID: args.siteID,
        languages: result
      }
    });
  }

  return result;
};

exports.updateLanguage = updateLanguage;

const deleteLanguage = async (args, dispatch, config) => {
  const result = await _services.languageServices.deleteLanguage(args, dispatch, config);

  if (result) {
    dispatch({
      type: 'DELETE_LANGUAGE',
      payload: args
    });
  }

  return result;
};

exports.deleteLanguage = deleteLanguage;

const updateSettings = async (args, dispatch, config) => {
  const result = await _services.languageServices.updateSettings(args, dispatch, config);

  if (result) {
    const {
      siteID
    } = args,
          rest = (0, _objectWithoutProperties2.default)(args, ["siteID"]);
    dispatch({
      type: 'UPDATE_LANGUAGE_SETTINGS',
      payload: {
        siteID,
        settings: rest
      }
    });
  }

  return result;
};

exports.updateSettings = updateSettings;

const translatePost = async (args, dispatch, config) => {
  const result = await _services.languageServices.translatePost(args, dispatch, config);

  if (result) {
    dispatch({
      type: 'ADD_POST',
      payload: _objectSpread(_objectSpread({}, result), {}, {
        siteID: args.siteID
      })
    });
    dispatch({
      type: 'ADD_EDITOR_POST',
      payload: _objectSpread(_objectSpread({}, result), {}, {
        siteID: args.siteID
      })
    });
  }

  return result;
};

exports.translatePost = translatePost;

const translateTerm = async (args, dispatch, config) => {
  const result = await _services.languageServices.translateTerm(args, dispatch, config);

  if (result) {
    dispatch({
      type: 'ADD_TERM',
      payload: _objectSpread(_objectSpread({}, result), {}, {
        siteID: args.siteID
      })
    });
  }

  return result;
};

exports.translateTerm = translateTerm;

const translateMass = async (args, dispatch, config) => {
  const result = await _services.languageServices.translateMass(args, dispatch, config);

  if (result) {
    dispatch({
      type: 'SET_LANGUAGE_IN_MASS',
      payload: args
    });
  }

  return result;
};

exports.translateMass = translateMass;