"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deleteUser = exports.updateUser = exports.getUsers = exports.getUser = exports.addUser = void 0;

var _services = require("../services");

const addUser = async (_ref, dispatch, config) => {
  let {
    siteID,
    email,
    role,
    sendEmail
  } = _ref;
  const result = await _services.userServices.addUser({
    siteID,
    email,
    role,
    sendEmail
  }, dispatch, config);
  return result;
};

exports.addUser = addUser;

const getUser = async (_ref2, dispatch, config) => {
  let {
    siteID,
    id
  } = _ref2;
  const result = await _services.userServices.getUser({
    siteID,
    id
  }, dispatch, config);
  return result;
};

exports.getUser = getUser;

const getUsers = async (_ref3, dispatch, config) => {
  let {
    siteID,
    page,
    limit
  } = _ref3;
  const result = await _services.userServices.getUsers({
    siteID,
    page,
    limit
  }, dispatch, config);
  return result;
};

exports.getUsers = getUsers;

const updateUser = async (_ref4, dispatch, config) => {
  let {
    siteID,
    id,
    role
  } = _ref4;
  const result = await _services.userServices.updateUser({
    siteID,
    id,
    role
  }, dispatch, config);
  return result;
};

exports.updateUser = updateUser;

const deleteUser = async (_ref5, dispatch, config) => {
  let {
    siteID,
    id
  } = _ref5;
  const result = await _services.userServices.deleteUser({
    siteID,
    id
  }, dispatch, config);
  return result;
};

exports.deleteUser = deleteUser;