"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _htmlReactParser = _interopRequireDefault(require("html-react-parser"));

var _router = require("@reach/router");

var _antd = require("antd");

var _icons = require("@ant-design/icons");

var _Caption = _interopRequireDefault(require("./Caption"));

var _Select = _interopRequireDefault(require("./Select"));

var _utils = require("../utils");

var _store = require("../store");

var _templateObject;

const LanguageList = props => {
  var _sites$siteID, _sites$siteID$languag, _sites$siteID$languag2, _sites$siteID2, _sites$siteID2$langua, _sites$siteID2$langua2;

  const {
    onChange
  } = props;
  const [{
    config,
    cmsState: {
      siteID,
      sites
    },
    editorState: {
      post,
      postHasChanged,
      siteHasChanged
    }
  }, dispatch] = (0, _store.useStore)();
  const [loading, setLoading] = (0, _react.useState)('');

  const handleTranslatePost = async (_ref) => {
    let {
      id,
      language
    } = _ref;
    setLoading(language);
    await (0, _utils.translatePost)({
      sites,
      siteID,
      id,
      language
    }, dispatch, config);
    setLoading('');
  };

  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical",
    size: 20
  }, /*#__PURE__*/_react.default.createElement(_Select.default, {
    label: "Language",
    value: (post === null || post === void 0 ? void 0 : post.language) || 'none',
    onChange: onChange
  }, !(post !== null && post !== void 0 && post.language) && /*#__PURE__*/_react.default.createElement(_antd.Select.Option, {
    value: "none"
  }, "Select..."), (_sites$siteID = sites[siteID]) === null || _sites$siteID === void 0 ? void 0 : (_sites$siteID$languag = _sites$siteID.languages) === null || _sites$siteID$languag === void 0 ? void 0 : (_sites$siteID$languag2 = _sites$siteID$languag.languages) === null || _sites$siteID$languag2 === void 0 ? void 0 : _sites$siteID$languag2.map(o => /*#__PURE__*/_react.default.createElement(_antd.Select.Option, {
    key: o.id,
    value: o.slug,
    children: o.name
  }))), (post === null || post === void 0 ? void 0 : post.language) && /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical",
    size: 6
  }, /*#__PURE__*/_react.default.createElement(_Caption.default, {
    children: "Translations"
  }), /*#__PURE__*/_react.default.createElement(_antd.List, {
    itemLayout: "vertical",
    size: "small",
    bordered: true,
    dataSource: (_sites$siteID2 = sites[siteID]) === null || _sites$siteID2 === void 0 ? void 0 : (_sites$siteID2$langua = _sites$siteID2.languages) === null || _sites$siteID2$langua === void 0 ? void 0 : (_sites$siteID2$langua2 = _sites$siteID2$langua.languages) === null || _sites$siteID2$langua2 === void 0 ? void 0 : _sites$siteID2$langua2.filter(p => p.slug !== (post === null || post === void 0 ? void 0 : post.language)),
    renderItem: language => {
      var _post$translations;

      let icon = null;

      let _onClick = () => {};

      let tooltip = '';
      let title = '';

      if (post !== null && post !== void 0 && (_post$translations = post.translations) !== null && _post$translations !== void 0 && _post$translations[language.slug]) {
        var _sites$siteID$postTyp, _sites$siteID$postTyp2, _sites$siteID$postTyp3, _sites$siteID$postTyp4, _post$translations2;

        tooltip = 'Edit translation';
        icon = /*#__PURE__*/_react.default.createElement(_icons.EditTwoTone, null);

        _onClick = () => (0, _router.navigate)((0, _utils.generateSlug)({
          site: sites[siteID],
          postTypeID: post.postTypeID,
          postID: post.translations[language.slug],
          leadingSlash: true
        }));

        title = (_sites$siteID$postTyp = sites[siteID].postTypes) === null || _sites$siteID$postTyp === void 0 ? void 0 : (_sites$siteID$postTyp2 = _sites$siteID$postTyp[post === null || post === void 0 ? void 0 : post.postTypeID]) === null || _sites$siteID$postTyp2 === void 0 ? void 0 : (_sites$siteID$postTyp3 = _sites$siteID$postTyp2.posts) === null || _sites$siteID$postTyp3 === void 0 ? void 0 : (_sites$siteID$postTyp4 = _sites$siteID$postTyp3[post === null || post === void 0 ? void 0 : (_post$translations2 = post.translations) === null || _post$translations2 === void 0 ? void 0 : _post$translations2[language.slug]]) === null || _sites$siteID$postTyp4 === void 0 ? void 0 : _sites$siteID$postTyp4.title;
      } else {
        const isLoading = loading === language.slug;
        tooltip = 'Add translation';
        icon = /*#__PURE__*/_react.default.createElement(_icons.PlusCircleTwoTone, {
          spin: isLoading
        });

        _onClick = () => !isLoading && handleTranslatePost({
          id: post.id,
          language: language.slug
        });
      }

      return /*#__PURE__*/_react.default.createElement(_antd.Popconfirm, {
        placement: "bottomRight",
        title: "Discard unsaved changes?",
        onConfirm: _onClick,
        disabled: !postHasChanged && !siteHasChanged
      }, /*#__PURE__*/_react.default.createElement(_antd.List.Item, {
        key: language.id,
        extra: /*#__PURE__*/_react.default.createElement(IconContainer, null, /*#__PURE__*/_react.default.createElement(_antd.Tooltip, {
          title: tooltip,
          placement: "left"
        }, /*#__PURE__*/_react.default.createElement(_antd.Button, {
          type: "text",
          shape: "circle",
          icon: icon,
          onClick: () => !postHasChanged && !siteHasChanged && _onClick()
        })))
      }, /*#__PURE__*/_react.default.createElement(_antd.Space, null, /*#__PURE__*/_react.default.createElement(IconContainer, {
        children: language.flag && (0, _htmlReactParser.default)(language.flag)
      }), title)));
    }
  }))));
};

const IconContainer = _styledComponents.default.div(_templateObject || (_templateObject = (0, _taggedTemplateLiteral2.default)(["\n  display: flex;\n  align-items: center;\n  height: 22px;\n  width: 22px;\n"])));

var _default = LanguageList;
exports.default = _default;