"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _htmlReactParser = _interopRequireDefault(require("html-react-parser"));

var _antd = require("antd");

var _icons = require("@ant-design/icons");

var _store = require("../store");

var _templateObject, _templateObject2, _templateObject3;

const LanguageSelector = props => {
  var _sites$siteID, _sites$siteID$languag, _sites$siteID$languag2;

  const {
    post,
    onEdit,
    onTranslate
  } = props;
  const [{
    cmsState: {
      siteID,
      sites
    }
  }] = (0, _store.useStore)();
  const [loading, setLoading] = (0, _react.useState)('');

  const handleTranslate = async (_ref) => {
    let {
      id,
      language
    } = _ref;
    setLoading(language);
    await onTranslate({
      id,
      language
    });
    setLoading('');
  };

  return /*#__PURE__*/_react.default.createElement(Container, null, (_sites$siteID = sites[siteID]) === null || _sites$siteID === void 0 ? void 0 : (_sites$siteID$languag = _sites$siteID.languages) === null || _sites$siteID$languag === void 0 ? void 0 : (_sites$siteID$languag2 = _sites$siteID$languag.languages) === null || _sites$siteID$languag2 === void 0 ? void 0 : _sites$siteID$languag2.map(p => {
    var _post$translations;

    const flag = p.flag && (0, _htmlReactParser.default)(p.flag);

    if (post.language === p.slug) {
      return /*#__PURE__*/_react.default.createElement(Item, {
        key: p.id,
        onClick: () => onEdit(p.slug)
      }, flag);
    } else if ((_post$translations = post.translations) !== null && _post$translations !== void 0 && _post$translations[p.slug]) {
      return /*#__PURE__*/_react.default.createElement(_antd.Tooltip, {
        key: p.id,
        title: "Edit translation",
        mouseEnterDelay: 0.5
      }, /*#__PURE__*/_react.default.createElement(Item, {
        onClick: () => onEdit(p.slug)
      }, flag, /*#__PURE__*/_react.default.createElement(IconContainer, null, /*#__PURE__*/_react.default.createElement(_icons.EditTwoTone, null))));
    } else {
      const isLoading = loading === p.slug;
      return /*#__PURE__*/_react.default.createElement(_antd.Tooltip, {
        key: p.id,
        title: "Add translation",
        mouseEnterDelay: 0.5
      }, /*#__PURE__*/_react.default.createElement(Item, {
        onClick: () => !isLoading && handleTranslate({
          id: post.id,
          language: p.slug
        })
      }, flag, /*#__PURE__*/_react.default.createElement(IconContainer, null, /*#__PURE__*/_react.default.createElement(_icons.PlusCircleTwoTone, {
        spin: isLoading
      }))));
    }
  }));
};

const Container = _styledComponents.default.div(_templateObject || (_templateObject = (0, _taggedTemplateLiteral2.default)(["\n  display: flex;\n  align-items: center;\n"])));

const Item = _styledComponents.default.div(_templateObject2 || (_templateObject2 = (0, _taggedTemplateLiteral2.default)(["\n  position: relative;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  width: 32px;\n  height: 32px;\n  margin: 0 10px;\n  cursor: pointer;\n"])));

const IconContainer = _styledComponents.default.div(_templateObject3 || (_templateObject3 = (0, _taggedTemplateLiteral2.default)(["\n  position: absolute;\n  bottom: 0;\n  right: 0;\n  z-index: 1;\n"])));

var _default = LanguageSelector;
exports.default = _default;