"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _Input = _interopRequireDefault(require("./Input"));

var _Caption = _interopRequireDefault(require("./Caption"));

var _store = require("../store");

// import app components
const UserForm = props => {
  var _sites$siteID;

  const {
    id,
    email: defaultEmail = '',
    roles: defaultRoles = ['editor'],
    onAdd,
    onUpdate
  } = props;
  const [{
    cmsState: {
      sites,
      siteID
    }
  }, dispatch] = (0, _store.useStore)();
  const [loading, setLoading] = (0, _react.useState)(false);
  const [email, setEmail] = (0, _react.useState)(defaultEmail);
  const [roles, setRoles] = (0, _react.useState)(defaultRoles);
  const [sendEmail, setSendEmail] = (0, _react.useState)(true);
  const userExists = !!id;

  const handleSubmit = async () => {
    if (!email || !roles.length) {
      return;
    }

    setLoading(true);

    if (id) {
      await onUpdate({
        id,
        role: roles[0]
      });
    } else {
      await onAdd({
        email,
        role: roles[0],
        sendEmail
      });
    }

    setLoading(false);
    dispatch({
      type: 'CLOSE_DIALOG'
    });
  };

  return /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical",
    size: 20
  }, /*#__PURE__*/_react.default.createElement(_Input.default, {
    label: "Email",
    value: email,
    onChange: e => setEmail(e.target.value),
    placeholder: '',
    disabled: !!defaultEmail,
    onKeyDown: e => e.key === 'Enter' && handleSubmit()
  }), /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical",
    size: 2
  }, /*#__PURE__*/_react.default.createElement(_Caption.default, {
    children: "Role"
  }), /*#__PURE__*/_react.default.createElement(_antd.Select, {
    defaultValue: (roles === null || roles === void 0 ? void 0 : roles[0]) || (defaultRoles === null || defaultRoles === void 0 ? void 0 : defaultRoles[0]),
    onChange: v => setRoles([v])
  }, (_sites$siteID = sites[siteID]) === null || _sites$siteID === void 0 ? void 0 : _sites$siteID.userRoles.map(o => {
    return /*#__PURE__*/_react.default.createElement(_antd.Select.Option, {
      key: o.id,
      value: o.id,
      children: o.name
    });
  }))), !id && /*#__PURE__*/_react.default.createElement(_antd.Checkbox, {
    checked: sendEmail,
    onChange: e => setSendEmail(e.target.checked)
  }, "Send new user email"), /*#__PURE__*/_react.default.createElement(_antd.Button, {
    children: userExists ? 'Update' : 'Add',
    onClick: handleSubmit,
    type: "primary",
    loading: loading
  }));
};

var _default = UserForm;
exports.default = _default;