"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _Editor = _interopRequireDefault(require("./Editor"));

var _Loader = _interopRequireDefault(require("../Loader"));

var _utils = require("../../utils");

var _store = require("../../store");

var _actions = require("../../actions");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

const PreviewEditor = props => {
  const [loading, setLoading] = (0, _react.useState)(true);
  const [{
    config,
    cmsState: {
      siteID
    },
    editorState: {
      post
    }
  }, dispatch] = (0, _store.useStore)();
  (0, _react.useEffect)(() => {
    const loadPost = async () => {
      const previewID = _utils.auth.getPreviewID();

      const result = await _actions.previewActions.getPostPreview({
        siteID,
        previewID
      }, dispatch, config);

      if (result) {
        dispatch({
          type: 'ADD_POST',
          payload: _objectSpread(_objectSpread({}, result), {}, {
            siteID
          })
        });
        dispatch({
          type: 'ADD_EDITOR_POST',
          payload: _objectSpread(_objectSpread({}, result), {}, {
            siteID
          })
        });
      }

      setLoading(false);
    };

    loadPost();
    return () => dispatch({
      type: "CLEAR_EDITOR"
    });
  }, []);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, loading ? /*#__PURE__*/_react.default.createElement(_Loader.default, {
    text: "Load Preview"
  }) : /*#__PURE__*/_react.default.createElement(_Editor.default, (0, _extends2.default)({
    postID: post === null || post === void 0 ? void 0 : post.id
  }, props)));
};

var _default = PreviewEditor;
exports.default = _default;