"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _htmlReactParser = _interopRequireDefault(require("html-react-parser"));

var _Select = _interopRequireDefault(require("../Select"));

var _Input = _interopRequireDefault(require("../Input"));

var _actions = require("../../actions");

var _store = require("../../store");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

const LanguageForm = props => {
  const {
    language: defaultLanguage = {
      id: null,
      name: '',
      slug: '',
      locale: ''
    }
  } = props;
  const [{
    config,
    cmsState: {
      siteID
    }
  }, dispatch] = (0, _store.useStore)();
  const [loadingLanguages, setLoadingLanguages] = (0, _react.useState)(true);
  const [loading, setLoading] = (0, _react.useState)(false);
  const [languages, setLanguages] = (0, _react.useState)([]);
  const [language, setLanguage] = (0, _react.useState)(defaultLanguage);
  (0, _react.useEffect)(() => {
    // Load language options for select field
    const loadLanguages = async () => {
      const result = await _actions.languageActions.getLanguages({}, dispatch, config);

      if (result) {
        setLanguages(result);
      }

      setLoadingLanguages(false);
    };

    loadLanguages();
  }, []);

  const handleChange = e => setLanguage(_objectSpread(_objectSpread({}, language), {}, {
    [e.target.name]: e.target.value
  }));

  const handleUpsert = async () => {
    const {
      id,
      name,
      slug,
      locale
    } = language;

    if (!name || !slug || !locale) {
      return;
    }

    setLoading(true);

    if (id) {
      await _actions.languageActions.updateLanguage({
        siteID,
        id,
        name,
        slug,
        locale
      }, dispatch, config);
    } else {
      await _actions.languageActions.addLanguage({
        siteID,
        name,
        slug,
        locale
      }, dispatch, config);
    } // Reset to default and close modal


    setLanguage({
      id: null,
      name: '',
      slug: '',
      locale: ''
    });
    setLoading(false);
    dispatch({
      type: 'CLOSE_DIALOG'
    });
  };

  return /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical",
    size: 20
  }, /*#__PURE__*/_react.default.createElement(_Select.default, {
    showSearch: true,
    optionFilterProp: "children",
    filterOption: (input, option) => option.children.toLowerCase().indexOf(input.toLowerCase()) >= 0,
    filterSort: (optionA, optionB) => optionA.children.toLowerCase().localeCompare(optionB.children.toLowerCase()),
    value: language.locale,
    onChange: value => {
      const selectedLanguage = languages.find(o => o.locale === value) || {};
      setLanguage(_objectSpread(_objectSpread({}, language), selectedLanguage));
    },
    label: 'Select a language',
    loading: loadingLanguages
  }, languages.map(o => /*#__PURE__*/_react.default.createElement(_antd.Select.Option, {
    key: o.locale,
    value: o.locale,
    children: (0, _htmlReactParser.default)("".concat(o.name, " - ").concat(o.locale))
  }))), /*#__PURE__*/_react.default.createElement(_Input.default, {
    label: "Name",
    name: "name",
    value: language.name,
    onChange: handleChange
  }), /*#__PURE__*/_react.default.createElement(_Input.default, {
    label: "Language Code",
    name: "slug",
    value: language.slug,
    onChange: handleChange
  }), /*#__PURE__*/_react.default.createElement(_Input.default, {
    label: "Locale",
    name: "locale",
    value: language.locale,
    disabled: true
  }), /*#__PURE__*/_react.default.createElement(_antd.Button, {
    id: "add-language",
    children: language !== null && language !== void 0 && language.id ? 'Update' : 'Add',
    onClick: handleUpsert,
    type: "primary",
    disabled: !language.name || !language.slug || !language.locale,
    loading: loading
  }));
};

var _default = LanguageForm;
exports.default = _default;