"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _Input = _interopRequireDefault(require("../Input"));

var _Select = _interopRequireDefault(require("../Select"));

var _store = require("../../store");

// import app components
const PostForm = props => {
  var _sites$siteID, _sites$siteID$languag, _sites$siteID2, _sites$siteID2$langua, _sites$siteID2$langua2, _sites$siteID3, _sites$siteID3$langua, _sites$siteID3$langua2, _sites$siteID4, _sites$siteID4$langua, _sites$siteID4$langua2;

  const {
    postTypeID,
    onSubmit
  } = props;
  const [{
    cmsState: {
      sites,
      siteID,
      activeLanguage
    }
  }, dispatch] = (0, _store.useStore)();
  const defaultLanguage = activeLanguage === 'all' ? (_sites$siteID = sites[siteID]) === null || _sites$siteID === void 0 ? void 0 : (_sites$siteID$languag = _sites$siteID.languages) === null || _sites$siteID$languag === void 0 ? void 0 : _sites$siteID$languag.defaultLanguage : activeLanguage;
  const [title, setTitle] = (0, _react.useState)('');
  const [language, setLanguage] = (0, _react.useState)(defaultLanguage);
  const [loading, setLoading] = (0, _react.useState)(false); // Check if post type supports languages

  const postTypeSupportsLanguages = !!((_sites$siteID2 = sites[siteID]) !== null && _sites$siteID2 !== void 0 && (_sites$siteID2$langua = _sites$siteID2.languages) !== null && _sites$siteID2$langua !== void 0 && (_sites$siteID2$langua2 = _sites$siteID2$langua.postTypes) !== null && _sites$siteID2$langua2 !== void 0 && _sites$siteID2$langua2.find(s => s === postTypeID));

  const handleSubmit = async () => {
    if (!title) {
      return;
    }

    setLoading(true);
    await onSubmit({
      postTypeID,
      title,
      language
    });
    setTitle('');
    setLoading(false);
    dispatch({
      type: 'CLOSE_DIALOG'
    });
  };

  return /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical",
    size: 20
  }, /*#__PURE__*/_react.default.createElement(_Input.default, {
    id: "post-title",
    label: "Title",
    value: title,
    onChange: e => setTitle(e.target.value),
    placeholder: '',
    onKeyDown: e => e.key === 'Enter' && handleSubmit()
  }), postTypeSupportsLanguages && ((_sites$siteID3 = sites[siteID]) === null || _sites$siteID3 === void 0 ? void 0 : (_sites$siteID3$langua = _sites$siteID3.languages) === null || _sites$siteID3$langua === void 0 ? void 0 : (_sites$siteID3$langua2 = _sites$siteID3$langua.languages) === null || _sites$siteID3$langua2 === void 0 ? void 0 : _sites$siteID3$langua2.length) > 0 && /*#__PURE__*/_react.default.createElement(_Select.default, {
    label: "Language",
    value: language,
    onChange: value => setLanguage(value)
  }, (_sites$siteID4 = sites[siteID]) === null || _sites$siteID4 === void 0 ? void 0 : (_sites$siteID4$langua = _sites$siteID4.languages) === null || _sites$siteID4$langua === void 0 ? void 0 : (_sites$siteID4$langua2 = _sites$siteID4$langua.languages) === null || _sites$siteID4$langua2 === void 0 ? void 0 : _sites$siteID4$langua2.map(o => /*#__PURE__*/_react.default.createElement(_antd.Select.Option, {
    key: o.id,
    value: o.slug,
    children: o.name
  }))), /*#__PURE__*/_react.default.createElement(_antd.Button, {
    id: "submit-create-post",
    children: "Add",
    onClick: handleSubmit,
    type: "primary",
    disabled: !title,
    loading: loading
  }));
};

var _default = PostForm;
exports.default = _default;