"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _Select = _interopRequireDefault(require("../Select"));

var _Input = _interopRequireDefault(require("../Input"));

var _store = require("../../store");

// import app components
const TermForm = props => {
  var _sites$siteID, _sites$siteID$languag, _sites$siteID2, _sites$siteID2$langua, _sites$siteID2$langua2, _sites$siteID3, _sites$siteID3$langua, _sites$siteID3$langua2;

  const {
    id,
    title: defaultTitle = '',
    slug: defaultSlug = '',
    parentID: defaultParentID = 0,
    description: defaultDescription = '',
    language: defaultLanguage = '',
    taxonomyID,
    terms,
    onSubmit
  } = props;
  const termExists = !!id;
  const [{
    cmsState: {
      sites,
      siteID,
      activeLanguage
    }
  }, dispatch] = (0, _store.useStore)();
  const initialLanguage = defaultLanguage ? defaultLanguage : activeLanguage === 'all' ? (_sites$siteID = sites[siteID]) === null || _sites$siteID === void 0 ? void 0 : (_sites$siteID$languag = _sites$siteID.languages) === null || _sites$siteID$languag === void 0 ? void 0 : _sites$siteID$languag.defaultLanguage : activeLanguage;
  const [title, setTitle] = (0, _react.useState)(defaultTitle);
  const [slug, setSlug] = (0, _react.useState)(defaultSlug);
  const [parentID, setParentID] = (0, _react.useState)(defaultParentID);
  const [description, setDescription] = (0, _react.useState)(defaultDescription);
  const [language, setLanguage] = (0, _react.useState)(initialLanguage);
  const [loading, setLoading] = (0, _react.useState)(false); // Check if taxonomy supports languages

  const taxonomySupportsLanguages = !!((_sites$siteID2 = sites[siteID]) !== null && _sites$siteID2 !== void 0 && (_sites$siteID2$langua = _sites$siteID2.languages) !== null && _sites$siteID2$langua !== void 0 && (_sites$siteID2$langua2 = _sites$siteID2$langua.taxonomies) !== null && _sites$siteID2$langua2 !== void 0 && _sites$siteID2$langua2.find(s => s === taxonomyID));

  const handleSubmit = async () => {
    if (!title) {
      return;
    }

    setLoading(true);
    await onSubmit({
      id,
      title,
      slug,
      parentID,
      description,
      language
    });
    setLoading(false);
    dispatch({
      type: 'CLOSE_DIALOG'
    });
  };

  return /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical",
    size: 20
  }, /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical"
  }, /*#__PURE__*/_react.default.createElement(_Input.default, {
    label: "Title",
    value: title,
    onChange: e => setTitle(e.target.value),
    onKeyDown: e => e.key === 'Enter' && handleSubmit()
  }), /*#__PURE__*/_react.default.createElement(_Input.default, {
    label: "slug",
    value: slug,
    onChange: e => setSlug(e.target.value),
    onKeyDown: e => e.key === 'Enter' && handleSubmit()
  }), taxonomySupportsLanguages && /*#__PURE__*/_react.default.createElement(_Select.default, {
    label: "Language",
    value: language,
    onChange: value => setLanguage(value)
  }, (_sites$siteID3 = sites[siteID]) === null || _sites$siteID3 === void 0 ? void 0 : (_sites$siteID3$langua = _sites$siteID3.languages) === null || _sites$siteID3$langua === void 0 ? void 0 : (_sites$siteID3$langua2 = _sites$siteID3$langua.languages) === null || _sites$siteID3$langua2 === void 0 ? void 0 : _sites$siteID3$langua2.map(o => /*#__PURE__*/_react.default.createElement(_antd.Select.Option, {
    key: o.id,
    value: o.slug,
    children: o.name
  }))), /*#__PURE__*/_react.default.createElement(_Input.default, {
    rows: 4,
    label: "Description",
    value: description,
    allowClear: true,
    onChange: e => setDescription(e.target.value),
    onKeyDown: e => e.key === 'Enter' && handleSubmit()
  }), /*#__PURE__*/_react.default.createElement(_Select.default, {
    value: parentID,
    onChange: value => setParentID(value),
    label: 'Parent'
  }, /*#__PURE__*/_react.default.createElement(_antd.Select.Option, {
    value: 0,
    children: "None"
  }), terms && Object.values(terms).filter(o => o.id !== id).map(o => /*#__PURE__*/_react.default.createElement(_antd.Select.Option, {
    key: o.id,
    value: o.id,
    children: o.title
  })))), /*#__PURE__*/_react.default.createElement(_antd.Button, {
    children: termExists ? 'Update' : 'Add',
    onClick: handleSubmit,
    type: "primary",
    block: true,
    loading: loading
  }));
};

var _default = TermForm;
exports.default = _default;