"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _router = require("@reach/router");

var _antd = require("antd");

var _Home = _interopRequireDefault(require("../../pages/Home"));

var _Profile = _interopRequireDefault(require("../../pages/Profile"));

var _Dashboard = _interopRequireDefault(require("../../pages/Dashboard"));

var _Media = _interopRequireDefault(require("../../pages/Media"));

var _PostType = _interopRequireDefault(require("../../pages/PostType"));

var _GeneralSettings = _interopRequireDefault(require("../../pages/GeneralSettings"));

var _Taxonomy = _interopRequireDefault(require("../../pages/Taxonomy"));

var _Users = _interopRequireDefault(require("../../pages/Users"));

var _AdminEditor = _interopRequireDefault(require("../editor/AdminEditor"));

var _theme = require("../../theme");

var _store = require("../../store");

var _routes = require("../../routes");

// import components
const AdminRouter = props => {
  var _authUser$capabilitie, _authUser$capabilitie2;

  const [{
    config,
    authState: {
      authUser
    },
    appState: {
      dialog
    },
    cmsState: {
      sites,
      siteID
    }
  }, dispatch] = (0, _store.useStore)();
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_theme.CmsStyles, null), /*#__PURE__*/_react.default.createElement(_router.Router, null, !!config.multisite && /*#__PURE__*/_react.default.createElement(_Home.default, {
    path: "".concat(_routes.ROUTE_APP)
  }), /*#__PURE__*/_react.default.createElement(_Profile.default, {
    path: "".concat(_routes.ROUTE_APP).concat(_routes.ROUTE_PROFILE)
  }), /*#__PURE__*/_react.default.createElement(_Dashboard.default, {
    path: "".concat(_routes.ROUTE_APP).concat(_routes.ROUTE_SITE, "/:siteID")
  }), /*#__PURE__*/_react.default.createElement(_Media.default, {
    path: "".concat(_routes.ROUTE_APP).concat(_routes.ROUTE_SITE, "/:siteID").concat(_routes.ROUTE_MEDIA)
  }), /*#__PURE__*/_react.default.createElement(_PostType.default, {
    path: "".concat(_routes.ROUTE_APP).concat(_routes.ROUTE_SITE, "/:siteID").concat(_routes.ROUTE_POST_TYPE, "/:postTypeID")
  }), /*#__PURE__*/_react.default.createElement(_Taxonomy.default, {
    path: "".concat(_routes.ROUTE_APP).concat(_routes.ROUTE_SITE, "/:siteID").concat(_routes.ROUTE_TAXONOMY, "/:taxonomyID")
  }), (authUser === null || authUser === void 0 ? void 0 : (_authUser$capabilitie = authUser.capabilities) === null || _authUser$capabilitie === void 0 ? void 0 : _authUser$capabilitie.manage_options) && /*#__PURE__*/_react.default.createElement(_GeneralSettings.default, {
    path: "".concat(_routes.ROUTE_APP).concat(_routes.ROUTE_SITE, "/:siteID").concat(_routes.ROUTE_SETTINGS_GENERAL)
  }), (authUser === null || authUser === void 0 ? void 0 : (_authUser$capabilitie2 = authUser.capabilities) === null || _authUser$capabilitie2 === void 0 ? void 0 : _authUser$capabilitie2.list_users) && /*#__PURE__*/_react.default.createElement(_Users.default, {
    path: "".concat(_routes.ROUTE_APP).concat(_routes.ROUTE_SITE, "/:siteID").concat(_routes.ROUTE_USERS)
  }), /*#__PURE__*/_react.default.createElement(_AdminEditor.default, (0, _extends2.default)({
    path: '*'
  }, props))), dialog.open && /*#__PURE__*/_react.default.createElement(_antd.Modal, {
    transitionName: "none",
    maskTransitionName: "none",
    title: dialog.title,
    visible: true,
    onCancel: () => dispatch({
      type: 'CLOSE_DIALOG'
    }),
    destroyOnClose: true,
    children: dialog.component,
    width: dialog.width,
    footer: null
  }));
};

var _default = AdminRouter;
exports.default = _default;