"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _htmlReactParser = _interopRequireDefault(require("html-react-parser"));

var _Select = _interopRequireDefault(require("../Select"));

var _LanguageForm = _interopRequireDefault(require("../forms/LanguageForm"));

var _store = require("../../store");

var _actions = require("../../actions");

var _Caption = _interopRequireDefault(require("../Caption"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

const LanguageSettings = () => {
  var _sites$siteID, _sites$siteID2, _sites$siteID2$langua, _sites$siteID2$langua2, _sites$siteID3, _sites$siteID3$langua, _sites$siteID3$langua2;

  const [{
    config,
    cmsState: {
      sites,
      siteID
    }
  }, dispatch] = (0, _store.useStore)();
  const languages = (_sites$siteID = sites[siteID]) === null || _sites$siteID === void 0 ? void 0 : _sites$siteID.languages;
  const [postTypes, setPostTypes] = (0, _react.useState)(languages === null || languages === void 0 ? void 0 : languages.postTypes);
  const [taxonomies, setTaxonomies] = (0, _react.useState)(languages === null || languages === void 0 ? void 0 : languages.taxonomies);
  const [defaultLanguage, setDefaultLanguage] = (0, _react.useState)(languages === null || languages === void 0 ? void 0 : languages.defaultLanguage);
  const [loading, setLoading] = (0, _react.useState)(null);
  (0, _react.useEffect)(() => {
    // Update default language (changes when first language is added or current default language gets deleted)
    setDefaultLanguage(languages === null || languages === void 0 ? void 0 : languages.defaultLanguage);
  }, [languages === null || languages === void 0 ? void 0 : languages.defaultLanguage]);

  const handleUpdate = async () => {
    setLoading({
      action: 'update-settings'
    });
    const result = await _actions.languageActions.updateSettings({
      siteID,
      defaultLanguage,
      postTypes,
      taxonomies
    }, dispatch, config);

    if (result) {
      _antd.message.success('Updated successfully');
    }

    setLoading(null);
  };

  const handleOpenForm = async function handleOpenForm() {
    let language = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
    dispatch({
      type: 'SET_DIALOG',
      payload: {
        open: true,
        title: !!(language !== null && language !== void 0 && language.id) ? 'Edit' : 'Add',
        component: /*#__PURE__*/_react.default.createElement(_LanguageForm.default, {
          language: language
        })
      }
    });
  };

  const handleDeleteLanguage = async language => {
    setLoading({
      id: language.id,
      action: 'delete-language'
    });
    await _actions.languageActions.deleteLanguage(_objectSpread({
      siteID
    }, language), dispatch, config);
    setLoading(null);
  };

  return /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical",
    size: 40
  }, /*#__PURE__*/_react.default.createElement(_antd.Card, {
    title: "Languages",
    extra: [/*#__PURE__*/_react.default.createElement(_antd.Button, {
      key: "add-language",
      type: "primary",
      onClick: handleOpenForm,
      children: "Add"
    })]
  }, /*#__PURE__*/_react.default.createElement(_antd.Table, {
    pagination: false,
    dataSource: ((_sites$siteID2 = sites[siteID]) === null || _sites$siteID2 === void 0 ? void 0 : (_sites$siteID2$langua = _sites$siteID2.languages) === null || _sites$siteID2$langua === void 0 ? void 0 : (_sites$siteID2$langua2 = _sites$siteID2$langua.languages) === null || _sites$siteID2$langua2 === void 0 ? void 0 : _sites$siteID2$langua2.map(o => {
      return _objectSpread(_objectSpread({}, o), {}, {
        key: o.id
      });
    })) || []
  }, /*#__PURE__*/_react.default.createElement(_antd.Table.Column, {
    title: "Flag",
    dataIndex: "flag",
    key: "flag",
    render: img => img && (0, _htmlReactParser.default)(img)
  }), /*#__PURE__*/_react.default.createElement(_antd.Table.Column, {
    title: "Name",
    dataIndex: "name",
    key: "name",
    width: "100%"
  }), /*#__PURE__*/_react.default.createElement(_antd.Table.Column, {
    title: "Locale",
    dataIndex: "locale",
    key: "locale"
  }), /*#__PURE__*/_react.default.createElement(_antd.Table.Column, {
    title: "Code",
    dataIndex: "slug",
    key: "slug"
  }), /*#__PURE__*/_react.default.createElement(_antd.Table.Column, {
    title: "Action",
    key: "action",
    render: (text, language) => /*#__PURE__*/_react.default.createElement(_antd.Space, {
      key: language.id
    }, /*#__PURE__*/_react.default.createElement(_antd.Button, {
      children: "Edit",
      onClick: () => handleOpenForm(language),
      type: "primary"
    }), /*#__PURE__*/_react.default.createElement(_antd.Popconfirm, {
      title: "Are you sure?",
      onConfirm: () => handleDeleteLanguage(language),
      okText: "Yes",
      okButtonProps: {
        id: 'delete-media-confirm'
      },
      cancelText: "No"
    }, /*#__PURE__*/_react.default.createElement(_antd.Button, {
      id: "delete-language",
      children: "Delete",
      danger: true,
      loading: (loading === null || loading === void 0 ? void 0 : loading.action) === 'delete-language' && (loading === null || loading === void 0 ? void 0 : loading.id) === language.id
    })))
  }))), /*#__PURE__*/_react.default.createElement(_antd.Card, {
    title: "Settings"
  }, /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical",
    size: 30
  }, /*#__PURE__*/_react.default.createElement(_Select.default, {
    label: "Default Language",
    value: defaultLanguage,
    onChange: value => setDefaultLanguage(value)
  }, (_sites$siteID3 = sites[siteID]) === null || _sites$siteID3 === void 0 ? void 0 : (_sites$siteID3$langua = _sites$siteID3.languages) === null || _sites$siteID3$langua === void 0 ? void 0 : (_sites$siteID3$langua2 = _sites$siteID3$langua.languages) === null || _sites$siteID3$langua2 === void 0 ? void 0 : _sites$siteID3$langua2.map(o => /*#__PURE__*/_react.default.createElement(_antd.Select.Option, {
    key: o.slug,
    value: o.slug,
    children: o.name
  }))), /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical",
    size: 6
  }, /*#__PURE__*/_react.default.createElement(_Caption.default, {
    children: "Post Types"
  }), /*#__PURE__*/_react.default.createElement(_antd.Checkbox.Group, {
    options: Object.values(sites[siteID].postTypes).filter(o => {
      var _config$fields;

      return !!(config !== null && config !== void 0 && (_config$fields = config.fields) !== null && _config$fields !== void 0 && _config$fields.postTypes[o.id]);
    }).map(o => {
      return {
        value: o.id,
        label: o.title,
        disabled: o.id === 'page' || o.id === 'post'
      };
    }),
    defaultValue: postTypes,
    onChange: values => setPostTypes(values)
  })), /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical",
    size: 6
  }, /*#__PURE__*/_react.default.createElement(_Caption.default, {
    children: "Taxonomies"
  }), /*#__PURE__*/_react.default.createElement(_antd.Checkbox.Group, {
    options: Object.values(sites[siteID].taxonomies).filter(o => {
      var _config$fields2;

      return !!(config !== null && config !== void 0 && (_config$fields2 = config.fields) !== null && _config$fields2 !== void 0 && _config$fields2.taxonomies.find(p => p.id === o.id));
    }).map(o => {
      return {
        value: o.id,
        label: o.title,
        disabled: o.id === 'category' || o.id === 'post_tag'
      };
    }),
    defaultValue: taxonomies,
    onChange: values => setTaxonomies(values)
  })), /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical",
    size: 6
  }, /*#__PURE__*/_react.default.createElement(_Caption.default, {
    children: "URL modifications"
  }), /*#__PURE__*/_react.default.createElement(_antd.Radio.Group, {
    onChange: () => {},
    value: 'directory'
  }, /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical"
  }, /*#__PURE__*/_react.default.createElement(_antd.Radio, {
    value: 'directory'
  }, "Directory: https://test.com/en/my-post/"), /*#__PURE__*/_react.default.createElement(_antd.Radio, {
    value: 'subdomain',
    disabled: true
  }, "Subdomains: https://en.test.com/my-post/"), /*#__PURE__*/_react.default.createElement(_antd.Radio, {
    value: 'different-domains',
    disabled: true
  }, "Different domains")))), /*#__PURE__*/_react.default.createElement(_antd.Button, {
    onClick: handleUpdate,
    children: "Update",
    type: "primary",
    loading: (loading === null || loading === void 0 ? void 0 : loading.action) === 'update-settings'
  }))));
};

var _default = LanguageSettings;
exports.default = _default;