"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = require("react");

var _store = require("../store");

var _actions = require("../actions");

var _auth = require("../utils/auth");

// import components
const useAuth = () => {
  const [{
    config
  }, dispatch] = (0, _store.useStore)();
  const [timer, setTimer] = (0, _react.useState)(0);
  const user = (0, _auth.getUser)();
  (0, _react.useEffect)(() => {
    let intervalID = null;

    if (user !== null && user !== void 0 && user.authToken) {
      intervalID = setInterval(() => {
        setTimer(time => time + 1);
      }, 90000); // 90 seconds
    } // Clear timer


    return () => {
      intervalID && clearInterval(intervalID);
    };
  }, []);
  (0, _react.useEffect)(() => {
    const refreshToken = async () => {
      await _actions.authActions.refreshToken({}, dispatch, config);
    };

    if (timer > 0) {
      refreshToken();
    }
  }, [timer]);
  (0, _react.useEffect)(() => {
    const loadUser = async () => {
      await _actions.authActions.getAuthUser({}, dispatch, config);
    };

    if (user !== null && user !== void 0 && user.authToken) {
      loadUser();
    }
  }, []);
};

var _default = useAuth;
exports.default = _default;