"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = require("react");

var _store = require("../store");

var _actions = require("../actions");

var _auth = require("../utils/auth");

// import components
const useSite = () => {
  const [{
    config,
    authState: {
      authUser
    },
    editorState: {
      siteHasChanged
    }
  }, dispatch] = (0, _store.useStore)(); // timer for refresh token and site updates

  const [timer, setTimer] = (0, _react.useState)(0);
  const previewID = (0, _auth.getPreviewID)();
  (0, _react.useEffect)(() => {
    const intervalID = setInterval(() => {
      setTimer(time => time + 1);
    }, 60000); // 60 seconds
    // Clear timer

    return () => {
      clearInterval(intervalID);
    };
  }, []);
  (0, _react.useEffect)(() => {
    var _authUser$capabilitie;

    const loadSite = async () => {
      await _actions.siteActions.getSite({
        siteID: config.siteID,
        siteHasChanged
      }, dispatch, config);
    };

    (authUser === null || authUser === void 0 ? void 0 : (_authUser$capabilitie = authUser.capabilities) === null || _authUser$capabilitie === void 0 ? void 0 : _authUser$capabilitie.edit_posts) && loadSite();
  }, [timer, authUser]);
  (0, _react.useEffect)(() => {
    const loadPreview = async () => {
      await _actions.previewActions.getSitePreview({
        siteID: config.siteID,
        previewID
      }, dispatch, config);
    };

    if (previewID) {
      loadPreview();
    }
  }, [previewID]);
};

var _default = useSite;
exports.default = _default;