"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "LoginForm", {
  enumerable: true,
  get: function get() {
    return _LoginForm.default;
  }
});
Object.defineProperty(exports, "RichText", {
  enumerable: true,
  get: function get() {
    return _RichText.default;
  }
});
Object.defineProperty(exports, "GatsbyImage", {
  enumerable: true,
  get: function get() {
    return _GatsbyImage.default;
  }
});
Object.defineProperty(exports, "isLoggedIn", {
  enumerable: true,
  get: function get() {
    return _auth.isLoggedIn;
  }
});
Object.defineProperty(exports, "logout", {
  enumerable: true,
  get: function get() {
    return _auth.logout;
  }
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _router = require("@reach/router");

var _JamCMS = _interopRequireDefault(require("./components/JamCMS"));

var _LoginForm = _interopRequireDefault(require("./components/LoginForm"));

var _RichText = _interopRequireDefault(require("./components/RichText"));

var _GatsbyImage = _interopRequireDefault(require("./components/GatsbyImage"));

var _Seo = _interopRequireDefault(require("./components/Seo"));

var _auth = require("./utils/auth");

var _utils = require("./utils");

// import app components
const Index = props => {
  const {
    source,
    settings,
    children
  } = props; // Check if user has access to jamCMS.

  const allowAccess = (0, _utils.validateAccess)();

  if (allowAccess) {
    var _children$props, _children$props$locat;

    // Redirect to default site if no multisite is detected
    if ((children === null || children === void 0 ? void 0 : (_children$props = children.props) === null || _children$props === void 0 ? void 0 : (_children$props$locat = _children$props.location) === null || _children$props$locat === void 0 ? void 0 : _children$props$locat.pathname) === '/jam-cms' && !(settings !== null && settings !== void 0 && settings.multisite)) {
      return /*#__PURE__*/_react.default.createElement(_router.Redirect, {
        to: "/jam-cms/site/default",
        noThrow: true
      });
    } else {
      return /*#__PURE__*/_react.default.createElement(_JamCMS.default, props);
    }
  } else {
    (0, _auth.deleteUser)();
    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_Seo.default, props), /*#__PURE__*/_react.default.cloneElement(children, {
      source
    }));
  }
};

var _default = Index; // Export all useful frontend components / functions

exports.default = _default;