"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _router = require("@reach/router");

var _immer = _interopRequireDefault(require("immer"));

var _reactBeautifulDnd = require("react-beautiful-dnd");

var _antd = require("antd");

var _CmsLayout = _interopRequireDefault(require("../components/CmsLayout"));

var _PostForm = _interopRequireDefault(require("../components/forms/PostForm"));

var _ListItem = _interopRequireDefault(require("../components/ListItem"));

var _Loader = _interopRequireDefault(require("../components/Loader"));

var _Tag = _interopRequireDefault(require("../components/Tag"));

var _LanguageSelector = _interopRequireDefault(require("../components/LanguageSelector"));

var _actions = require("../actions");

var _store = require("../store");

var _utils = require("../utils");

var _theme = require("../theme");

var _routes = _interopRequireDefault(require("../routes"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

const PostType = props => {
  var _sites$siteID, _sites$siteID$languag, _sites$siteID$languag2, _sites$siteID2, _sites$siteID2$postTy, _sites$siteID3, _config$fields3, _config$fields3$postT, _config$fields3$postT2;

  const {
    postTypeID
  } = props;
  const [{
    config,
    cmsState: {
      sites,
      siteID,
      activeLanguage
    }
  }, dispatch] = (0, _store.useStore)();
  const [filter, setFilter] = (0, _react.useState)('all');
  const [category, setCategory] = (0, _react.useState)(null);
  const [search, setSearch] = (0, _react.useState)('');
  const [loading, setLoading] = (0, _react.useState)(''); // Check if post type supports languages

  const postTypeSupportsLanguages = !!((_sites$siteID = sites[siteID]) !== null && _sites$siteID !== void 0 && (_sites$siteID$languag = _sites$siteID.languages) !== null && _sites$siteID$languag !== void 0 && (_sites$siteID$languag2 = _sites$siteID$languag.postTypes) !== null && _sites$siteID$languag2 !== void 0 && _sites$siteID$languag2.find(s => s === postTypeID));
  const postType = (_sites$siteID2 = sites[siteID]) === null || _sites$siteID2 === void 0 ? void 0 : (_sites$siteID2$postTy = _sites$siteID2.postTypes) === null || _sites$siteID2$postTy === void 0 ? void 0 : _sites$siteID2$postTy[postTypeID];
  const posts = postType !== null && postType !== void 0 && postType.posts ? Object.values(postType.posts) : []; // Check if there are untranslated posts

  const postsWithoutLanguage = postTypeSupportsLanguages && posts.find(o => !o.language); // Filter by language

  const postsPerLanguage = postTypeSupportsLanguages ? posts.filter(o => activeLanguage === 'all' ? o : o.language === activeLanguage) : posts;
  let visiblePosts = []; // Filter by category

  visiblePosts = !!category ? postsPerLanguage.filter(o => {
    var _o$taxonomies, _o$taxonomies$categor;

    return o === null || o === void 0 ? void 0 : (_o$taxonomies = o.taxonomies) === null || _o$taxonomies === void 0 ? void 0 : (_o$taxonomies$categor = _o$taxonomies[category === null || category === void 0 ? void 0 : category.taxonomy]) === null || _o$taxonomies$categor === void 0 ? void 0 : _o$taxonomies$categor.includes(category.term);
  }) : postsPerLanguage; // Filter by post status

  visiblePosts = filter === 'all' ? visiblePosts.filter(o => o.status !== 'trash') : visiblePosts.filter(o => o.status === filter); // Filter by search query

  visiblePosts = search ? visiblePosts.filter(o => o.title.toLowerCase().includes(search)) : visiblePosts; // Sort posts by menu order

  visiblePosts = visiblePosts.sort((a, b) => a.order > b.order ? 1 : -1); // Create data tree

  visiblePosts = (0, _utils.createDataTree)(visiblePosts);
  const taxonomies = sites[siteID] && Object.values((_sites$siteID3 = sites[siteID]) === null || _sites$siteID3 === void 0 ? void 0 : _sites$siteID3.taxonomies).filter(o => o === null || o === void 0 ? void 0 : o.postTypes.includes(postTypeID));
  (0, _react.useEffect)(() => {
    var _config$fields, _config$fields$postTy;

    // Navigate to dashboard if template not found in fields object
    if (!(config !== null && config !== void 0 && (_config$fields = config.fields) !== null && _config$fields !== void 0 && (_config$fields$postTy = _config$fields.postTypes) !== null && _config$fields$postTy !== void 0 && _config$fields$postTy[postTypeID])) {
      (0, _router.navigate)((0, _routes.default)('dashboard', {
        siteID
      }));
    }
  }, []);
  (0, _react.useEffect)(() => {
    // Reset state to fix bug when user switches from one post type directly to another
    setFilter('all');
    setCategory(null);
    setSearch('');
  }, [postTypeID]);

  const handleSync = async () => {
    var _sites$siteID4;

    setLoading('sync');
    await _actions.siteActions.syncFields({
      fields: config.fields,
      apiKey: (_sites$siteID4 = sites[siteID]) === null || _sites$siteID4 === void 0 ? void 0 : _sites$siteID4.apiKey
    }, dispatch, config);
    setLoading('');
  };

  const handleTranslateMass = async () => {
    var _sites$siteID5, _sites$siteID5$langua;

    setLoading('translate');
    const language = activeLanguage !== 'all' ? activeLanguage : (_sites$siteID5 = sites[siteID]) === null || _sites$siteID5 === void 0 ? void 0 : (_sites$siteID5$langua = _sites$siteID5.languages) === null || _sites$siteID5$langua === void 0 ? void 0 : _sites$siteID5$langua.defaultLanguage;
    await _actions.languageActions.translateMass({
      siteID,
      postTypeID,
      type: 'post',
      ids: posts.filter(o => !o.language).map(o => o.id),
      language
    }, dispatch, config);
    setLoading('');
  };

  const handleDuplicatePost = async (_ref) => {
    let {
      postID
    } = _ref;
    await _actions.postActions.duplicatePost({
      siteID,
      id: postID
    }, dispatch, config);
  };

  const handleDeletePost = async (_ref2) => {
    let {
      postID
    } = _ref2;
    await _actions.postActions.deletePost({
      siteID,
      postTypeID,
      id: postID
    }, dispatch, config);
  };

  const handleAddPost = async args => {
    await (0, _utils.addPost)(_objectSpread({
      site: sites[siteID]
    }, args), dispatch, config);
  };

  const handleTrashPost = async (_ref3) => {
    let {
      postID
    } = _ref3;
    const result = await _actions.postActions.updatePost({
      siteID,
      postTypeID,
      id: postID,
      status: 'trash'
    }, dispatch, config);

    if (result) {
      _antd.message.info('Post has been trashed');
    }
  };

  const handleEmptyTrash = async () => {
    setLoading('empty-trash');
    const result = await _actions.postActions.emptyTrash({
      siteID,
      postTypeID,
      language: activeLanguage
    }, dispatch, config);

    if (result) {
      _antd.message.info({
        content: 'Trashed emptied successfully'
      });
    }

    setLoading('');
  };

  const handleTranslatePost = async (_ref4) => {
    let {
      id,
      language
    } = _ref4;
    await (0, _utils.translatePost)({
      sites,
      siteID,
      id,
      language
    }, dispatch, config);
  };

  const renderUntranslatedPostsWarning = () => {
    var _sites$siteID6, _sites$siteID6$langua, _sites$siteID7, _sites$siteID7$langua, _sites$siteID7$langua2;

    const languageSlug = activeLanguage !== 'all' ? activeLanguage : (_sites$siteID6 = sites[siteID]) === null || _sites$siteID6 === void 0 ? void 0 : (_sites$siteID6$langua = _sites$siteID6.languages) === null || _sites$siteID6$langua === void 0 ? void 0 : _sites$siteID6$langua.defaultLanguage;

    if (!languageSlug) {
      return null;
    }

    const languageName = (_sites$siteID7 = sites[siteID]) === null || _sites$siteID7 === void 0 ? void 0 : (_sites$siteID7$langua = _sites$siteID7.languages) === null || _sites$siteID7$langua === void 0 ? void 0 : (_sites$siteID7$langua2 = _sites$siteID7$langua.languages.find(o => o.slug === languageSlug)) === null || _sites$siteID7$langua2 === void 0 ? void 0 : _sites$siteID7$langua2.name;
    return /*#__PURE__*/_react.default.createElement(_antd.Alert, {
      message: "There are posts without a language",
      type: "info",
      showIcon: true,
      action: /*#__PURE__*/_react.default.createElement(_antd.Button, {
        size: "small",
        type: "ghost",
        onClick: handleTranslateMass,
        loading: loading === 'translate'
      }, "Translate to ", languageName)
    });
  };

  const filterItems = /*#__PURE__*/_react.default.createElement(_antd.Tabs, {
    defaultActiveKey: "all",
    onChange: v => setFilter(v)
  }, ['all', 'publish', 'draft', 'private', 'trash'].map(name => {
    const count = name === 'all' ? postsPerLanguage.filter(o => o.status !== 'trash').length : postsPerLanguage.filter(o => o.status === name).length;
    return /*#__PURE__*/_react.default.createElement(_antd.Tabs.TabPane, {
      key: name,
      tab: "".concat(name.toUpperCase(), " (").concat(count, ")")
    });
  }));

  const extra = [];

  if (taxonomies && taxonomies.length > 0) {
    extra.push( /*#__PURE__*/_react.default.createElement(_antd.Select, {
      key: "taxonomies",
      style: {
        width: 160
      },
      onChange: (v, o) => setCategory(o !== null && o !== void 0 && o.taxonomy ? {
        taxonomy: o.taxonomy,
        term: v
      } : ''),
      value: category === null || category === void 0 ? void 0 : category.term,
      allowClear: true,
      placeholder: "Select category"
    }, taxonomies.filter(o => {
      var _config$fields2;

      return !!(config !== null && config !== void 0 && (_config$fields2 = config.fields) !== null && _config$fields2 !== void 0 && _config$fields2.taxonomies.find(p => p.id === o.id));
    }).map(o => {
      return /*#__PURE__*/_react.default.createElement(_antd.Select.OptGroup, {
        key: o.id,
        label: o.title
      }, o.terms && Object.values(o.terms).map(p => {
        return /*#__PURE__*/_react.default.createElement(_antd.Select.Option, {
          key: p.id,
          value: p.id,
          taxonomy: o.id
        }, p.title);
      }));
    })));
  }

  extra.push( /*#__PURE__*/_react.default.createElement(_antd.Input.Search, {
    key: "search",
    allowClear: true,
    defaultValue: search,
    onChange: e => setSearch(e.target.value.toLowerCase()),
    style: {
      width: 180
    }
  }));

  if (filter === 'trash') {
    extra.push( /*#__PURE__*/_react.default.createElement(_antd.Popconfirm, {
      key: "empty-trash",
      title: "Are you sure you want to empty the trash?",
      onConfirm: handleEmptyTrash,
      okText: "Yes",
      cancelText: "No",
      placement: "bottomRight",
      disabled: visiblePosts.length === 0
    }, /*#__PURE__*/_react.default.createElement(_antd.Button, {
      children: 'Empty trash',
      disabled: visiblePosts.length === 0,
      type: "primary",
      danger: true,
      loading: loading === 'empty-trash'
    })));
  } else {
    extra.push( /*#__PURE__*/_react.default.createElement(_antd.Button, {
      key: "add",
      id: "create-post",
      children: "Add",
      disabled: !postType,
      onClick: () => dispatch({
        type: 'SET_DIALOG',
        payload: {
          open: true,
          title: "Add ".concat(postType.title),
          component: /*#__PURE__*/_react.default.createElement(_PostForm.default, {
            onSubmit: handleAddPost,
            postTypeID: postTypeID
          })
        }
      }),
      type: "primary"
    }));
  }

  const renderPost = (o, level) => {
    var _sites$siteID8, _o$translations, _sites$siteID9, _sites$siteID9$langua, _sites$siteID10, _o$seo, _o$locked;

    const slug = (0, _utils.generateSlug)({
      site: sites[siteID],
      postTypeID,
      postID: o.id,
      leadingSlash: true
    });
    const actions = [];
    const isLocked = !!o.locked;

    const menu = /*#__PURE__*/_react.default.createElement(_antd.Menu, null, /*#__PURE__*/_react.default.createElement(_antd.Menu.Item, {
      key: "edit",
      onClick: () => (0, _router.navigate)(slug)
    }, "Edit"), /*#__PURE__*/_react.default.createElement(_antd.Menu.Item, {
      key: "duplicate",
      onClick: () => handleDuplicatePost({
        postID: o.id
      })
    }, "Duplicate"), o.status === 'trash' ? /*#__PURE__*/_react.default.createElement(_antd.Menu.Item, {
      key: "delete",
      danger: true,
      onClick: () => handleDeletePost({
        postID: o.id
      }),
      disabled: isLocked
    }, "Delete") : /*#__PURE__*/_react.default.createElement(_antd.Menu.Item, {
      key: "trash",
      danger: true,
      onClick: () => handleTrashPost({
        postID: o.id
      }),
      disabled: isLocked
    }, "Trash"));

    actions.unshift( /*#__PURE__*/_react.default.createElement(_antd.Dropdown.Button, {
      key: "menu",
      overlay: menu,
      trigger: ['click']
    }));

    if (postTypeSupportsLanguages && o.language) {
      actions.unshift( /*#__PURE__*/_react.default.createElement(_LanguageSelector.default, {
        post: o,
        onTranslate: handleTranslatePost,
        onEdit: language => (0, _router.navigate)((0, _utils.generateSlug)({
          site: sites[siteID],
          postTypeID: o.postTypeID,
          postID: o.language === language ? o.id : o.translations[language],
          leadingSlash: true
        }))
      }));
    }

    let badges = [];

    if (((_sites$siteID8 = sites[siteID]) === null || _sites$siteID8 === void 0 ? void 0 : _sites$siteID8.frontPage) === o.id || (o === null || o === void 0 ? void 0 : (_o$translations = o.translations) === null || _o$translations === void 0 ? void 0 : _o$translations[(_sites$siteID9 = sites[siteID]) === null || _sites$siteID9 === void 0 ? void 0 : (_sites$siteID9$langua = _sites$siteID9.languages) === null || _sites$siteID9$langua === void 0 ? void 0 : _sites$siteID9$langua.defaultLanguage]) === ((_sites$siteID10 = sites[siteID]) === null || _sites$siteID10 === void 0 ? void 0 : _sites$siteID10.frontPage)) {
      badges.push( /*#__PURE__*/_react.default.createElement(_Tag.default, {
        key: "front",
        children: 'front'
      }));
    }

    if (o.status === 'draft' || o.status === 'trash' || o.status === 'private') {
      badges.push( /*#__PURE__*/_react.default.createElement(_Tag.default, {
        key: "status",
        children: o.status
      }));
    }

    if (((_o$seo = o.seo) === null || _o$seo === void 0 ? void 0 : _o$seo.metaRobotsNoindex) === 'noindex') {
      badges.push( /*#__PURE__*/_react.default.createElement(_Tag.default, {
        key: "noindex",
        children: "blocked"
      }));
    }

    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, {
      key: o.id
    }, /*#__PURE__*/_react.default.createElement(_ListItem.default, {
      level: level,
      actions: actions,
      title: o.title,
      subtitle: slug,
      status: badges,
      image: o.featuredImage,
      showImage: postTypeID !== 'page',
      link: slug,
      info: isLocked && "".concat((_o$locked = o.locked) === null || _o$locked === void 0 ? void 0 : _o$locked.email, " is currently editing")
    }), o.childNodes.map(p => renderPost(p, level + 1)));
  };

  const getListStyle = isDraggingOver => ({
    background: isDraggingOver ? _theme.colors.tertiary : 'transparent'
  });

  const getItemStyle = (isDragging, draggableStyle) => _objectSpread({
    userSelect: 'none',
    marginBottom: '8px'
  }, draggableStyle);

  const handleDragEnd = async result => {
    // dropped outside the list
    if (!result.destination) {
      return;
    }

    const index = result.source.index;
    const newIndex = result.destination.index;

    if (index === newIndex) {
      return;
    }

    const nextPosts = (0, _immer.default)(visiblePosts, draft => {
      if (newIndex > -1 && newIndex < draft.length) {
        const temp = draft[index];
        draft[index] = draft[newIndex];
        draft[newIndex] = temp;
        draft.map((o, i) => {
          return draft[i] = _objectSpread(_objectSpread({}, o), {}, {
            order: i
          });
        });
      }

      return draft;
    });
    await _actions.postActions.reorderPosts({
      siteID,
      postType,
      posts: nextPosts
    }, dispatch, config);
  };

  return /*#__PURE__*/_react.default.createElement(_CmsLayout.default, {
    pageTitle: (config === null || config === void 0 ? void 0 : (_config$fields3 = config.fields) === null || _config$fields3 === void 0 ? void 0 : (_config$fields3$postT = _config$fields3.postTypes) === null || _config$fields3$postT === void 0 ? void 0 : (_config$fields3$postT2 = _config$fields3$postT[postTypeID]) === null || _config$fields3$postT2 === void 0 ? void 0 : _config$fields3$postT2.title) || (postType === null || postType === void 0 ? void 0 : postType.title)
  }, sites[siteID] && !postType && /*#__PURE__*/_react.default.createElement(_antd.Alert, {
    message: "Unknown post type",
    description: "Restart the development process or sync new data now",
    type: "info",
    showIcon: true,
    action: /*#__PURE__*/_react.default.createElement(_antd.Button, {
      size: "small",
      type: "ghost",
      onClick: handleSync,
      loading: loading === 'sync'
    }, "Sync to WordPress")
  }), postsWithoutLanguage && renderUntranslatedPostsWarning(), /*#__PURE__*/_react.default.createElement(_antd.PageHeader, {
    title: filterItems,
    extra: extra
  }), sites[siteID] ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, visiblePosts && /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical",
    size: 8
  }, filter === 'all' && postTypeID !== 'page' ? /*#__PURE__*/_react.default.createElement(_reactBeautifulDnd.DragDropContext, {
    onDragEnd: handleDragEnd
  }, /*#__PURE__*/_react.default.createElement(_reactBeautifulDnd.Droppable, {
    droppableId: "droppable"
  }, (provided, snapshot) => /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({}, provided.droppableProps, {
    ref: provided.innerRef,
    style: getListStyle(snapshot.isDraggingOver)
  }), visiblePosts.map((o, i) => {
    return /*#__PURE__*/_react.default.createElement(_reactBeautifulDnd.Draggable, {
      key: o.id,
      draggableId: "item-".concat(o.id),
      index: i
    }, (provided, snapshot) => /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({
      ref: provided.innerRef
    }, provided.draggableProps, provided.dragHandleProps, {
      style: getItemStyle(snapshot.isDragging, provided.draggableProps.style)
    }), renderPost(o, 0)));
  }), provided.placeholder))) : visiblePosts.map(o => renderPost(o, 0)))) : /*#__PURE__*/_react.default.createElement(_Loader.default, {
    height: 'auto',
    py: 100
  }));
};

var _default = PostType;
exports.default = _default;