"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _CmsLayout = _interopRequireDefault(require("../components/CmsLayout"));

var _TermForm = _interopRequireDefault(require("../components/forms/TermForm"));

var _ListItem = _interopRequireDefault(require("../components/ListItem"));

var _LanguageSelector = _interopRequireDefault(require("../components/LanguageSelector"));

var _utils = require("../utils");

var _actions = require("../actions");

var _store = require("../store");

// import app components
const Taxonomy = props => {
  var _sites$siteID, _sites$siteID$taxonom, _config$fields, _sites$siteID2, _sites$siteID2$langua, _sites$siteID2$langua2, _config$fields2, _config$fields2$taxon, _config$fields2$taxon2;

  const {
    taxonomyID
  } = props;
  const [{
    config,
    cmsState: {
      siteID,
      sites,
      activeLanguage
    }
  }, dispatch] = (0, _store.useStore)();
  const [loading, setLoading] = (0, _react.useState)(null);
  const taxonomy = (_sites$siteID = sites[siteID]) === null || _sites$siteID === void 0 ? void 0 : (_sites$siteID$taxonom = _sites$siteID.taxonomies) === null || _sites$siteID$taxonom === void 0 ? void 0 : _sites$siteID$taxonom[taxonomyID];
  const terms = Object.values(taxonomy.terms);
  const hasTemplate = !!(config !== null && config !== void 0 && (_config$fields = config.fields) !== null && _config$fields !== void 0 && _config$fields.taxonomies.find(o => o.id === taxonomyID).component); // Check if taxonomy supports languages

  const taxonomySupportsLanguages = !!((_sites$siteID2 = sites[siteID]) !== null && _sites$siteID2 !== void 0 && (_sites$siteID2$langua = _sites$siteID2.languages) !== null && _sites$siteID2$langua !== void 0 && (_sites$siteID2$langua2 = _sites$siteID2$langua.taxonomies) !== null && _sites$siteID2$langua2 !== void 0 && _sites$siteID2$langua2.find(s => s === taxonomyID)); // Check if there are untranslated taxonomies

  const taxonomiesWithoutLanguage = taxonomySupportsLanguages && terms.find(o => !o.language); // Filter by language

  const termsPerLanguage = taxonomySupportsLanguages ? terms.filter(o => activeLanguage === 'all' ? o : o.language === activeLanguage) : terms;
  const treeTerms = termsPerLanguage ? (0, _utils.createDataTree)(termsPerLanguage) : [];

  const handleSync = async () => {
    var _sites$siteID3;

    setLoading({
      action: 'syncing'
    });
    await _actions.siteActions.syncFields({
      fields: config.fields,
      apiKey: (_sites$siteID3 = sites[siteID]) === null || _sites$siteID3 === void 0 ? void 0 : _sites$siteID3.apiKey
    }, dispatch, config);
    setLoading(null);
  };

  const handleTranslateMass = async () => {
    var _sites$siteID4, _sites$siteID4$langua;

    setLoading({
      action: 'translate'
    });
    const language = activeLanguage !== 'all' ? activeLanguage : (_sites$siteID4 = sites[siteID]) === null || _sites$siteID4 === void 0 ? void 0 : (_sites$siteID4$langua = _sites$siteID4.languages) === null || _sites$siteID4$langua === void 0 ? void 0 : _sites$siteID4$langua.defaultLanguage;
    await _actions.languageActions.translateMass({
      siteID,
      taxonomyID,
      type: 'term',
      ids: terms.filter(o => !o.language).map(o => o.id),
      language
    }, dispatch, config);
    setLoading(null);
  };

  const handleUpsert = async (_ref) => {
    let {
      id,
      title,
      slug,
      parentID,
      description,
      language
    } = _ref;

    if (id) {
      await _actions.termActions.updateTerm({
        siteID,
        taxonomyID,
        id,
        title,
        slug,
        parentID,
        description,
        language
      }, dispatch, config);
    } else {
      await _actions.termActions.addTerm({
        siteID,
        taxonomyID,
        id,
        title,
        slug,
        parentID,
        description,
        language
      }, dispatch, config);
    }
  };

  const handleDelete = async (_ref2) => {
    let {
      termID
    } = _ref2;
    setLoading({
      action: 'delete',
      id: termID
    });
    await _actions.termActions.deleteTerm({
      siteID,
      taxonomyID,
      id: termID
    }, dispatch, config);
    setLoading(null);
  };

  const handleOpenDialog = function handleOpenDialog() {
    let term = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    dispatch({
      type: 'SET_DIALOG',
      payload: {
        open: true,
        title: "Term",
        component: /*#__PURE__*/_react.default.createElement(_TermForm.default, (0, _extends2.default)({}, term, {
          taxonomyID: taxonomyID,
          terms: terms,
          onSubmit: handleUpsert
        }))
      }
    });
  };

  const handleEditTranslation = (term, language) => {
    if (term.language === language) {
      handleOpenDialog(term);
    } else if (term.translations[language]) {
      const translatedTerm = terms.find(o => o.id === term.translations[language]);
      handleOpenDialog(translatedTerm);
    }
  };

  const handleTranslateTerm = async (_ref3) => {
    let {
      id,
      language
    } = _ref3;
    const result = await (0, _utils.translateTerm)({
      sites,
      siteID,
      id,
      language
    }, dispatch, config);

    if (result) {
      handleOpenDialog(result);
    }
  };

  const renderUntranslatedTermsWarning = () => {
    var _sites$siteID5, _sites$siteID5$langua, _sites$siteID6, _sites$siteID6$langua, _sites$siteID6$langua2;

    const languageSlug = activeLanguage !== 'all' ? activeLanguage : (_sites$siteID5 = sites[siteID]) === null || _sites$siteID5 === void 0 ? void 0 : (_sites$siteID5$langua = _sites$siteID5.languages) === null || _sites$siteID5$langua === void 0 ? void 0 : _sites$siteID5$langua.defaultLanguage;

    if (!languageSlug) {
      return null;
    }

    const languageName = (_sites$siteID6 = sites[siteID]) === null || _sites$siteID6 === void 0 ? void 0 : (_sites$siteID6$langua = _sites$siteID6.languages) === null || _sites$siteID6$langua === void 0 ? void 0 : (_sites$siteID6$langua2 = _sites$siteID6$langua.languages.find(o => o.slug === languageSlug)) === null || _sites$siteID6$langua2 === void 0 ? void 0 : _sites$siteID6$langua2.name;
    return /*#__PURE__*/_react.default.createElement(_antd.Alert, {
      message: "There are terms without a language",
      type: "info",
      showIcon: true,
      action: /*#__PURE__*/_react.default.createElement(_antd.Button, {
        size: "small",
        type: "ghost",
        onClick: handleTranslateMass,
        loading: (loading === null || loading === void 0 ? void 0 : loading.action) === 'translate'
      }, "Translate to ", languageName)
    });
  };

  const renderTerm = (o, level) => {
    const actions = [];
    const slug = (0, _utils.generateSlug)({
      site: sites[siteID],
      taxonomyID: o.taxonomyID,
      termID: o.id,
      leadingSlash: true
    });
    actions.push( /*#__PURE__*/_react.default.createElement(_antd.Popconfirm, {
      title: "Are you sure?",
      onConfirm: () => handleDelete({
        termID: o.id
      }),
      okText: "Yes",
      cancelText: "No"
    }, /*#__PURE__*/_react.default.createElement(_antd.Button, {
      size: "small",
      children: "Delete",
      loading: (loading === null || loading === void 0 ? void 0 : loading.id) === o.id && (loading === null || loading === void 0 ? void 0 : loading.action) === 'delete',
      danger: true
    })));
    actions.push( /*#__PURE__*/_react.default.createElement(_antd.Button, {
      size: "small",
      children: "Edit",
      onClick: () => handleOpenDialog(o)
    })); // if (hasTemplate) {
    //   actions.push(
    //     <Link to={slug}>
    //       <Button size="small" children="View" />
    //     </Link>
    //   );
    // }

    if (taxonomySupportsLanguages && o.language) {
      actions.unshift( /*#__PURE__*/_react.default.createElement(_LanguageSelector.default, {
        post: o,
        onTranslate: handleTranslateTerm,
        onEdit: language => handleEditTranslation(o, language)
      }));
    }

    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, {
      key: o.id
    }, /*#__PURE__*/_react.default.createElement(_ListItem.default, {
      level: level,
      actions: actions,
      title: o.title,
      subtitle: slug
    }), o.childNodes.map(p => renderTerm(p, level + 1)));
  };

  return /*#__PURE__*/_react.default.createElement(_CmsLayout.default, {
    pageTitle: (config === null || config === void 0 ? void 0 : (_config$fields2 = config.fields) === null || _config$fields2 === void 0 ? void 0 : (_config$fields2$taxon = _config$fields2.taxonomies) === null || _config$fields2$taxon === void 0 ? void 0 : (_config$fields2$taxon2 = _config$fields2$taxon.find(o => o.id === taxonomyID)) === null || _config$fields2$taxon2 === void 0 ? void 0 : _config$fields2$taxon2.title) || (taxonomy === null || taxonomy === void 0 ? void 0 : taxonomy.title)
  }, taxonomiesWithoutLanguage && renderUntranslatedTermsWarning(), /*#__PURE__*/_react.default.createElement(_antd.PageHeader, null, /*#__PURE__*/_react.default.createElement(_antd.Button, {
    children: "Add",
    onClick: () => handleOpenDialog(),
    type: "primary",
    disabled: !taxonomy
  })), !taxonomy && /*#__PURE__*/_react.default.createElement(_antd.Alert, {
    message: "Unknown taxonomy",
    description: "Restart the development process or sync new data now",
    type: "info",
    showIcon: true,
    action: /*#__PURE__*/_react.default.createElement(_antd.Button, {
      size: "small",
      type: "ghost",
      onClick: handleSync,
      loading: (loading === null || loading === void 0 ? void 0 : loading.action) === 'syncing'
    }, "Sync to WordPress")
  }), /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical",
    size: 8
  }, treeTerms && treeTerms.map(item => renderTerm(item, 0))));
};

var _default = Taxonomy;
exports.default = _default;