"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.translateMass = exports.translateTerm = exports.translatePost = exports.updateSettings = exports.deleteLanguage = exports.updateLanguage = exports.addLanguage = exports.getLanguages = void 0;

var _ = require(".");

const getLanguages = async (_ref, dispatch, config) => {
  let {} = _ref;
  let result = await (0, _.db)('getLanguages', {}, dispatch, config);
  return result;
};

exports.getLanguages = getLanguages;

const addLanguage = async (_ref2, dispatch, config) => {
  let {
    siteID,
    name,
    slug,
    locale
  } = _ref2;
  let result = await (0, _.db)('addLanguage', {
    siteID,
    name,
    slug,
    locale
  }, dispatch, config);
  return result;
};

exports.addLanguage = addLanguage;

const updateLanguage = async (_ref3, dispatch, config) => {
  let {
    siteID,
    id,
    name,
    slug,
    locale
  } = _ref3;
  let result = await (0, _.db)('updateLanguage', {
    siteID,
    id,
    name,
    slug,
    locale
  }, dispatch, config);
  return result;
};

exports.updateLanguage = updateLanguage;

const deleteLanguage = async (_ref4, dispatch, config) => {
  let {
    siteID,
    id
  } = _ref4;
  let result = await (0, _.db)('deleteLanguage', {
    siteID,
    id
  }, dispatch, config);
  return result;
};

exports.deleteLanguage = deleteLanguage;

const updateSettings = async (_ref5, dispatch, config) => {
  let {
    siteID,
    defaultLanguage,
    postTypes,
    taxonomies
  } = _ref5;
  let result = await (0, _.db)('updateLanguageSettings', {
    siteID,
    defaultLanguage,
    postTypes: JSON.stringify(postTypes),
    taxonomies: JSON.stringify(taxonomies)
  }, dispatch, config);
  return result;
};

exports.updateSettings = updateSettings;

const translatePost = async (_ref6, dispatch, config) => {
  let {
    siteID,
    id,
    language
  } = _ref6;
  let result = await (0, _.db)('translatePost', {
    siteID,
    id,
    language
  }, dispatch, config);
  return result;
};

exports.translatePost = translatePost;

const translateTerm = async (_ref7, dispatch, config) => {
  let {
    siteID,
    id,
    language
  } = _ref7;
  let result = await (0, _.db)('translateTerm', {
    siteID,
    id,
    language
  }, dispatch, config);
  return result;
};

exports.translateTerm = translateTerm;

const translateMass = async (_ref8, dispatch, config) => {
  let {
    siteID,
    type,
    ids,
    language
  } = _ref8;
  let result = await (0, _.db)('setLanguageInMass', {
    siteID,
    type,
    ids: JSON.stringify(ids),
    language
  }, dispatch, config);
  return result;
};

exports.translateMass = translateMass;