"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.authReducer = exports.authState = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _immer = _interopRequireDefault(require("immer"));

var _auth = require("../utils/auth");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

// Get 'capabilities' information from local storage to avoid unnecessary waiting to fetch authUser.
// Technically, someone could manipulate those values manually, but the API call for site or post afterwards would fail anyway.
const storageUser = (0, _auth.getUser)();
const defaultState = {
  id: null,
  email: '',
  roles: '',
  capabilities: storageUser.capabilities
};

const authState = _objectSpread({}, defaultState);

exports.authState = authState;

const authReducer = (state, action) => {
  const {
    payload
  } = action;
  return (0, _immer.default)(state, draft => {
    switch (action.type) {
      case "ADD_AUTH_USER":
        draft.authUser = payload;
        break;

      case "REMOVE_AUTH_USER":
        draft.authUser = _objectSpread({}, defaultState);
        break;

      default:
    }
  });
};

exports.authReducer = authReducer;