"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = addPost;

var _router = require("@reach/router");

var _lodash = require("lodash");

var _immer = _interopRequireDefault(require("immer"));

var _actions = require("../actions");

var _generateSlug = _interopRequireDefault(require("./generateSlug"));

// import app components
async function addPost(_ref, dispatch, config) {
  let {
    site,
    postTypeID,
    title,
    language
  } = _ref;
  const result = await _actions.postActions.addPost({
    siteID: site.id,
    postTypeID,
    status: 'draft',
    title,
    language
  }, dispatch, config);

  if (result !== null && result !== void 0 && result.id) {
    // Add post to site so we can then generate the slug and the route the newly created post
    const nextSite = (0, _immer.default)(site, draft => {
      return (0, _lodash.set)(draft, "postTypes.".concat(result.postTypeID, ".posts.").concat(result.id), result);
    });
    const slug = (0, _generateSlug.default)({
      site: nextSite,
      postTypeID,
      postID: result.id,
      leadingSlash: true
    });
    (0, _router.navigate)(slug);
  }
}