"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = translatePost;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _router = require("@reach/router");

var _immer = _interopRequireDefault(require("immer"));

var _lodash = require("lodash");

var _actions = require("../actions");

var _generateSlug = _interopRequireDefault(require("./generateSlug"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

async function translatePost(_ref, dispatch, config) {
  let {
    sites,
    siteID,
    id,
    language
  } = _ref;
  const result = await _actions.languageActions.translatePost({
    siteID,
    id,
    language
  }, dispatch, config);

  if (result) {
    // We need to add update the translated posts, so they know about the new translation
    Object.keys(result.translations).map(k => {
      var _sites$siteID, _sites$siteID$postTyp;

      const nextPost = (0, _immer.default)((_sites$siteID = sites[siteID]) === null || _sites$siteID === void 0 ? void 0 : (_sites$siteID$postTyp = _sites$siteID.postTypes) === null || _sites$siteID$postTyp === void 0 ? void 0 : _sites$siteID$postTyp[result === null || result === void 0 ? void 0 : result.postTypeID].posts[result.translations[k]], draft => {
        (0, _lodash.set)(draft, "translations.".concat(result === null || result === void 0 ? void 0 : result.language), result === null || result === void 0 ? void 0 : result.id);
        return draft;
      });
      dispatch({
        type: 'ADD_POST',
        payload: _objectSpread(_objectSpread({}, nextPost), {}, {
          siteID
        })
      });
    }); // Add post to post type so we can then generate the slug and the route the newly created post

    const nextSite = (0, _immer.default)(sites[siteID], draft => {
      return (0, _lodash.set)(draft, "postTypes.".concat(result.postTypeID, ".posts.").concat(result.id), result);
    });
    const slug = (0, _generateSlug.default)({
      site: nextSite,
      postTypeID: result.postTypeID,
      postID: result.id,
      leadingSlash: true
    });
    (0, _router.navigate)(slug);
  }

  return result;
}