"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = translateTerm;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _immer = _interopRequireDefault(require("immer"));

var _lodash = require("lodash");

var _actions = require("../actions");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

async function translateTerm(_ref, dispatch, config) {
  let {
    sites,
    siteID,
    id,
    language
  } = _ref;
  const result = await _actions.languageActions.translateTerm({
    siteID,
    id,
    language
  }, dispatch, config);

  if (result) {
    // We need to add update the translated terms, so they know about the new translation
    Object.keys(result.translations).map(k => {
      var _sites$siteID, _sites$siteID$taxonom;

      const term = (_sites$siteID = sites[siteID]) === null || _sites$siteID === void 0 ? void 0 : (_sites$siteID$taxonom = _sites$siteID.taxonomies) === null || _sites$siteID$taxonom === void 0 ? void 0 : _sites$siteID$taxonom[result === null || result === void 0 ? void 0 : result.taxonomyID].terms[result.translations[k]];
      const nextTerm = (0, _immer.default)(term, draft => {
        (0, _lodash.set)(draft, "translations.".concat(result === null || result === void 0 ? void 0 : result.language), result === null || result === void 0 ? void 0 : result.id);
        return draft;
      });
      dispatch({
        type: 'UPDATE_TERM',
        payload: _objectSpread(_objectSpread({}, nextTerm), {}, {
          siteID
        })
      });
    });
  }

  return result;
}